
#include <eikapp.h>
#include <e32base.h>
#include <sdlapp.h>
#include <bautils.h>
#include <eikenv.h>
#include <stdlib.h>
#include <string.h>

#if defined (EPOC_AS_APP) && !defined (UIQ3) && !defined(S60V3)
#include "ECompXL.h"
#endif

class CHeroesApp : public CSDLApp {
public:
	CHeroesApp();
	~CHeroesApp();

	TUid AppDllUid() const;
#if defined (EPOC_AS_APP)  && !defined (UIQ3) && !defined(S60V3)
	TECompXL    iECompXL;
#endif

#if defined (UIQ3) 
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
	 * @return TInt, resource id
	 */
	TInt ViewResourceId();
#endif

};

#ifdef EPOC_AS_APP

// this function is called automatically by the SymbianOS to deliver the new CApaApplication object
#if !defined (UIQ3) && !defined(S60V3)
EXPORT_C 
#endif
CApaApplication* NewApplication() {
	// Return pointer to newly created CQMApp
	return new CHeroesApp;
}

#if defined (UIQ3) || defined (S60V3)
#include <eikstart.h>
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}
#endif

#endif // EPOC_AS_APP

#if !defined (UIQ3) && !defined (S60V3)
GLDEF_C  TInt E32Dll(TDllReason) {
	return KErrNone;
}
#endif
CHeroesApp::CHeroesApp() {
}

CHeroesApp::~CHeroesApp() {
}

#if defined (UIQ2) || defined (S60V2)
#define heroes_home_dir "c:\\documents\\heroes"
#define heroes_app_dir "c:\\system\\apps\\heroes"
#elif defined (UIQ3)
#define heroes_home_dir "c:\\shared\\heroes"
#define heroes_app_dir "c:\\resource\\apps\\heroes"
#elif defined (S60V3) 
#define heroes_home_dir "c:\\data\\heroes"
#define heroes_app_dir "c:\\resource\\apps\\heroes"
#endif
/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CHeroesApp::AppDllUid() const {
	
	char* appdir = strdup(heroes_app_dir);
 	appdir[0] = BitmapStoreName()[0];
	setenv("HEROES_HOME_DIR",heroes_home_dir, 1);
	setenv("HEROES_PREFIX",heroes_home_dir, 1);
	setenv("HEROES_DATA_DIR", appdir, 1);
	setenv("HEROES_LOCALE_DIR", appdir, 1);
	free(appdir);
	return TUid::Uid(0xA00007BC);
}
#if defined (UIQ3)
#include <Heroes.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CHeroesApp::ViewResourceId() {
	
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif

/////////////////////////////////////////////////////////////////////////////////////////////////


