/*------------------------------------------------------------------.
| Copyright 1997, 1998, 2000, 2001  Alexandre Duret-Lutz            |
|                                    <duret_g@epita.fr>             |
|                                                                   |
| This file is part of Heroes.                                      |
|                                                                   |
| Heroes is free software; you can redistribute it and/or modify it |
| under the terms of the GNU General Public License version 2 as    |
| published by the Free Software Foundation.                        |
|                                                                   |
| Heroes is distributed in the hope that it will be useful, but     |
| WITHOUT ANY WARRANTY; without even the implied warranty of        |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU |
| General Public License for more details.                          |
|                                                                   |
| You should have received a copy of the GNU General Public License |
| along with this program; if not, write to the Free Software       |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA          |
| 02111-1307 USA                                                    |
`------------------------------------------------------------------*/

#include "system.h"
#include <SDL_mixer.h>
#include "sfx.h"
#include "prefs.h"

void *
load_sfx_low (char *file)
{
  return Mix_LoadWAV (file);
}

void
free_sfx_low (void *sfx)
{
  Mix_FreeChunk (sfx);
}

void
play_sfx_low (void *sfx)
{
  Mix_Chunk *tmp = sfx;
    /* set the sample volume */
  tmp->volume = (13 - opt.sfx_volume) * MIX_MAX_VOLUME / 13;
  Mix_PlayChannel (-1, tmp, 0);
}

#include "system.h"
#include "keysdef.h"
#include <sdl_keyboard.h>

void create_keynames()
{
	FILE* f= fopen("c:\\keysdef.c","w");
	int loop;
	int l;
	if(f != NULL)
	{
		 fprintf(f,"/* Do not edit!\n" \
	      "   This file was generated by src/Makefile\n" \
	      "   from @SDL_KEYSYM_H@ */\n" \
	      "#include \"system.h\"\n" \
	      "#include <SDL.h>\n" \
	      "#include \"keysdef.h\"\n" \
	      "const struct keynames_s keynames[] = {");
		 for(loop = SDLK_FIRST;loop<SDLK_LAST;loop++)
		 {
			 char* keyname = SDL_GetKeyName(loop);
			 if(keyname != NULL && strlen(keyname)>0)
			 {
				 if(strcmp(keyname,"unknown key") != 0)
				 {
				 char* newkeyname = strdup(keyname);
				 for(l = 0;l<strlen(keyname);l++)
				 {
					 newkeyname[l] = toupper(keyname[l]);
				 }
				 fprintf(f, "\t{ \"%s\", %d} ,\n",newkeyname, loop);
				 free(newkeyname);
				 }
			 }
		 }
		 fprintf(f, "\t{ 0, 0 }};\n");
	}
	fclose(f);
}
